<?php

namespace FiloBlu\Storelocator\Model\Plugin\Rma;

use FiloBlu\Rma\Model\Rma\Status\HistoryFactory;
use FiloBlu\Rma\Model\RmaEmailManagment;
use FiloBlu\Storelocator\Helper\Data;

/**
 *
 */
class RmaEmailManagement
{
    /**
     * @var Data
     */
    protected $helper;
    /**
     * @var HistoryFactory
     */
    protected $historyFactory;

    /**
     * @param Data $helper
     * @param HistoryFactory $historyFactory
     */
    public function __construct(
        Data $helper,
        HistoryFactory $historyFactory
    )
    {
        $this->helper = $helper;
        $this->historyFactory = $historyFactory;
    }

    /**
     * @param RmaEmailManagment $subject
     * @param callable $proceed
     * @param $rmaEntityId
     * @param $status
     * @return mixed
     */
    public function  aroundSendRmaEmail(RmaEmailManagment $subject, callable $proceed, $rmaEntityId = null, $status = null) {

        if (!$this->helper->getReturnToStoreEnabled()) {
            return $proceed($rmaEntityId, $status);
        }

        if ($this->helper->getReturnToStoreEnabled() && $this->helper->getUseStandardRmaMailFlow()) {
            return $proceed($rmaEntityId, $status);
        }

        if ($status !== 'received') {
            return $proceed($rmaEntityId, $status);
        }

        // TODO: wrong logic.
        $path = RmaEmailManagment::XML_PATH_STATE_PREFIX . "_$status";
        if($status == 'authorized'){
            $path = RmaEmailManagment::XML_PATH_STATE_PREFIX . '_auth';
        }

        if($status == 'pending'){
            $path = RmaEmailManagment::XML_PATH_STATE_PREFIX ;
        }

        $statusHistory = $this->historyFactory->create();
        $statusHistory->setRmaEntityId($rmaEntityId);

        return $statusHistory->sendRmaEmail($path);
    }
}